<?php
//* *******Licence**************
//MyPlanet v0.3
//Auteurs : Sylvain Saleur
//syeric1@gmail.com
//Laurent Lamand
//
//
//Licence GNU GPL v3
//
//************************************************************

$feeds=array();
$categories=array();
$membres=array();
$config=array();
$users=array();
///////////////////////////////////////////////////////////Fonctions de traitement fichiers xml/////////////////////////////////////////////////////////////////


///////////////////////////////////////Fonctions d'administration des flux

//Intérogation ouverte pour les gens qui veulent me donner une leçon : une classe de traitement ne serait-elle pas plus indiquée ? A voir pour une prochaine version

function feed_add($feedlist2, $arr){ //fonction d'ajout d'un flux
	$arrkey=array_keys($feedlist2);
	$i=max($arrkey);
	$arra=array();
	$arra[$i+1]=$arr;
	$finaltab=array_merge($feedlist2, $arra);
	$file = fopen("../data/flux.xml","w");
	fwrite($file,"<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n");
	fwrite($file,"<planet>\n");
	foreach ($finaltab as $value=>$tab){
		fwrite($file,"<flux id='".$tab["ID"]."' nom='".$tab["NOM"]."' adresse='".$tab["ADRESSE"]."' name='".$tab["NAME"]."' adressesource='".$tab["ADRESSESOURCE"]."' refresh='".$tab["REFRESH"]."' nbarticles='".$tab["NBARTICLES"]."' categorie='".$tab["CATEGORIE"]."' ordre='".$tab["ORDRE"]."'>\n");
		fwrite($file,"</flux>\n");
		}
	fwrite($file,"</planet>");
	fclose($file);
	return true;
}

function feed_modif($feedlist1, $arr){ //fonction de modification d'un flux
	$ids=$arr["ID"];
	foreach ($feedlist1 as $key => $row) {
		$id[$key]  = $row['ID'];
	}

	array_multisort($id, SORT_ASC, $feedlist1);
	$feedlist2=array();
	foreach ($feedlist1 as $cle => $valeur){
		$feedlist2[$feedlist1[$cle]["ID"]]=$valeur;
	}
	$ordre_feeds=array();
	$ids=getkey($feedlist2, $ids);
	if ($feedlist2[$ids]["CATEGORIE"] != $arr["CATEGORIE"]){
		$cats=catList2();
		foreach ($cats as $key=> $val){//on récupère l'ordre maxi de la catégorie
			$ordre_feeds[$key]=0;
			foreach ($feedlist2 as $feed){
				if ($feed["CATEGORIE"]==$key){
					if($ordre_feed[$key]<$feed["ORDRE"]){
						$ordre_feeds[$key]=$feed["ORDRE"];
					}
				}
			}
		}
		$arr["ORDRE"]=$ordre_feeds[$arr["CATEGORIE"]]+1;
		
		//maintenant il faut modifier l'ordre des feeds de la catégorie d'où vient le feed
		$i=$feedlist2[$ids]["ORDRE"]-1;
		$cible=$feedlist2[$ids]["ORDRE"];
		$j=$ordre_feeds[$feedlist2[$ids]["CATEGORIE"]];
		//on génére un tableau des feeds de la catégorie
		$feedtmp=array();
		$feedlist3=$feedlist2;
		foreach($feedlist3 as $clow => $res){
			if ($res["CATEGORIE"]==$feedlist3[$ids]["CATEGORIE"]){
				$feedtmp[$clow]=$res;
				unset($feedlist2[$clow]);
			}
		}
		$ids2=getkey($feedtmp, $id);
		unset($feedtmp[$ids2]);
		//ordonnons les feeds par ordre
		$feedtmp=sortbyid($feedtmp);
		for ($i; $i<=$j; $i++){
			if($feedtmp[$i]['ORDRE']>$cible){
				$feedtmp[$i]['ORDRE']=$feedtmp[$i]['ORDRE']-1;
			}
		}
		$arra=array();
		$arra[$ids]=$arr;
		$finaltab=array_merge($feedlist2, $arra, $feedtmp);
	}
		else{
		$arra=array();
		$arra[$ids]=$arr;
		unset($feedlist2[$ids]);
		$finaltab=array_merge($feedlist2, $arra);
	}
	$file = fopen("../data/flux.xml","w");
	fwrite($file,"<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n");
	fwrite($file,"<planet>\n");
	foreach ($finaltab as $value=>$tab){
		fwrite($file,"<flux id='".$tab["ID"]."' nom='".$tab["NOM"]."' adresse='".$tab["ADRESSE"]."' name='".$tab["NAME"]."' adressesource='".$tab["ADRESSESOURCE"]."' refresh='".$tab["REFRESH"]."' nbarticles='".$tab["NBARTICLES"]."' categorie='".$tab["CATEGORIE"]."' ordre='".$tab["ORDRE"]."'>\n");
		fwrite($file,"</flux>\n");
		}
	fwrite($file,"</planet>");
	fclose($file);
	return true;
}

function feed_ordre($feedlist2, $arr){ //fonction de changement d'ordre d'un flux (elle m'a fait mal à la tête celle là, peut être trop complexe ? Si quelqu'un veut la simplifier...
	$id=$arr["ID"];
	$feedlist3=sortbyidbis($feedlist2);
	$ids=getkey($feedlist3, $id);
	$i=$arr["ORDRE"];
	$j=$feedlist3[$ids]["ORDRE"];
	//on crée un tableau avec les feeds de la catégorie concernée et on les enlève de feedlist2
	$arrsort=array();
	foreach ($feedlist2 as $key => $feed) {
		if ($feed["CATEGORIE"]==$arr["CATEGORIE"]){
			array_push($arrsort, $feed);
			unset($feedlist2[$key]);
		}
	}
	if ($i < $j){ //cas de la remontée
		for ($i;$i<$j;$i++){//arrsort est pour l'instant trié par ordre, on parcours les éléments affectés par la changement
			$arrsort[$i-1]["ORDRE"]=$arrsort[$i-1]["ORDRE"]+1;
		}
	}
	elseif ($i > $j){
		for ($j;$j<$i-1;$j++){
			$arrsort[$j]["ORDRE"]=$arrsort[$j]["ORDRE"]-1;
		}
	}
	else{ //cas de la fin
		for ($j;$j<max(array_keys($arrsort))+1;$j++){
			$arrsort[$j]["ORDRE"]=$arrsort[$j]["ORDRE"]-1;
		}
	}
	//on enlève le feed qu'on modifie à arrsort
	foreach ($arrsort as $keys => $val){
		if ($val["ID"]==$id){
			unset($arrsort[$keys]);
		}
	}
	if ($arr["ORDRE"]>$feedlist3[$ids]["ORDRE"]){
		$arr["ORDRE"]=$arr["ORDRE"]-1;
	}
	if ($arr["ORDRE"]==$feedlist3[$ids]["ORDRE"]){
		$arr["ORDRE"]=max(array_keys($arrsort))+1;
	}
	$arra=array();
	$arra[$ids]=$arr;
	$finaltab=array_merge($feedlist2, $arrsort, $arra);
	$file = fopen("../data/flux.xml","w");
	fwrite($file,"<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n");
	fwrite($file,"<planet>\n");
	foreach ($finaltab as $value=>$tab){
		fwrite($file,"<flux id='".$tab["ID"]."' nom='".$tab["NOM"]."' adresse='".$tab["ADRESSE"]."' name='".$tab["NAME"]."' adressesource='".$tab["ADRESSESOURCE"]."' refresh='".$tab["REFRESH"]."' nbarticles='".$tab["NBARTICLES"]."' categorie='".$tab["CATEGORIE"]."' ordre='".$tab["ORDRE"]."'>\n");
		fwrite($file,"</flux>\n");
		}
	fwrite($file,"</planet>");
	fclose($file);
	return true;
}

function suppr_feed($feedlist, $id){//fonction de suppression d'un flux
	//modification de l'ordre des flux de la même catégorie
	$ids=getkey($feedlist, $id);
	$cats=catList2();
	foreach ($cats as $key=> $val){//on récupère l'ordre maxi de la catégorie
		$ordre_feeds[$key]=0;
		foreach ($feedlist as $feed){
			if ($feed["CATEGORIE"]==$key){
				if($ordre_feed[$key]<$feed["ORDRE"]){
					$ordre_feeds[$key]=$feed["ORDRE"];
				}
			}
		}
	}
	$i=$feedlist[$ids]["ORDRE"]-1;
	$cible=$feedlist[$ids]["ORDRE"];
	$j=$ordre_feeds[$feedlist[$ids]["CATEGORIE"]];
	//on génére un tableau des feeds de la catégorie
	$feedtmp=array();
	$feedlist3=$feedlist;
	foreach($feedlist3 as $clow => $res){
		if ($res["CATEGORIE"]==$feedlist3[$ids]["CATEGORIE"]){
			$feedtmp[$clow]=$res;
			unset($feedlist[$clow]);
		}
	}
	$ids2=getkey($feedtmp, $id);
	unset($feedtmp[$ids2]);
	//ordonnons les feeds par ordre
	$feedtmp=sortbyid($feedtmp);
	for ($i; $i<=$j; $i++){
		if($feedtmp[$i]['ORDRE']>$cible){
			$feedtmp[$i]['ORDRE']=$feedtmp[$i]['ORDRE']-1;
		}
	}
	$finaltab=array_merge($feedlist, $feedtmp);
	//Et on écrit le fichier
	$file = fopen("../data/flux.xml","w");
	fwrite($file,"<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n");
	fwrite($file,"<planet>\n");
	foreach ($finaltab as $val=>$tab){
		fwrite($file,"<flux id='".$tab["ID"]."' nom='".$tab["NOM"]."' adresse='".$tab["ADRESSE"]."' name='".$tab["NAME"]."' adressesource='".$tab["ADRESSESOURCE"]."' refresh='".$tab["REFRESH"]."' nbarticles='".$tab["NBARTICLES"]."' categorie='".$tab["CATEGORIE"]."' ordre='".$tab["ORDRE"]."'>\n");
		fwrite($file,"</flux>\n");
		}
	fwrite($file,"</planet>");
	fclose($file);
	return true;
}

function suppr_feed_cat($feedlist, $cat){//fonction de suppression des flux associés à une catégorie
	foreach ($feedlist as $key => $value){
		if ($value["CATEGORIE"]==$cat){
			unset($feedlist[$key]);
		}
	}
	//Et on écrit le fichier
	$file = fopen("../data/flux.xml","w");
	fwrite($file,"<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n");
	fwrite($file,"<planet>\n");
	foreach ($feedlist as $val=>$tab){
		fwrite($file,"<flux id='".$tab["ID"]."' nom='".$tab["NOM"]."' adresse='".$tab["ADRESSE"]."' name='".$tab["NAME"]."' adressesource='".$tab["ADRESSESOURCE"]."' refresh='".$tab["REFRESH"]."' nbarticles='".$tab["NBARTICLES"]."' categorie='".$tab["CATEGORIE"]."' ordre='".$tab["ORDRE"]."'>\n");
		fwrite($file,"</flux>\n");
		}
	fwrite($file,"</planet>");
	fclose($file);
	return $feedlist;
}

function cge_cat_feed($feedlist3, $cible){//fonction qui change les catégories des flux lors de la suppression d'une catégorie
	foreach ($feedlist3 as $key => $value){
		if ($value["CATEGORIE"]>$cible){
			$feedlist3[$key]["CATEGORIE"]=$feedlist3[$key]["CATEGORIE"]-1;
		}
	}
	//Et on écrit le fichier
	$file = fopen("../data/flux.xml","w");
	fwrite($file,"<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n");
	fwrite($file,"<planet>\n");
	foreach ($feedlist3 as $val=>$tab){
		fwrite($file,"<flux id='".$tab["ID"]."' nom='".$tab["NOM"]."' adresse='".$tab["ADRESSE"]."' name='".$tab["NAME"]."' adressesource='".$tab["ADRESSESOURCE"]."' refresh='".$tab["REFRESH"]."' nbarticles='".$tab["NBARTICLES"]."' categorie='".$tab["CATEGORIE"]."' ordre='".$tab["ORDRE"]."'>\n");
		fwrite($file,"</flux>\n");
		}
	fwrite($file,"</planet>");
	fclose($file);
	return true;
}

///////////////////////////////////////////Fonctions d'aministration des catégories


function cat_add($catlist, $arr){ //Ajout d'une catégorie
	$arrkey=array_keys($catlist);
	$i=max($arrkey);
	$arra=array();
	$arra[$i+1]=$arr['NOM'];
	$finaltab=array_merge($catlist, $arra);
	$file=fopen("../data/categories.xml","w");
	fwrite($file,"<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n");
	fwrite($file,"<listecategories>\n");
	foreach ($finaltab as $key=> $val){
		fwrite($file,"<categorie id='".$key."' nom='".$val."'></categorie>\n");
	}
	fwrite($file,"</listecategories>\n");
	fclose($file);
	return true;
}


function cat_modif($catlist, $arr){ //Modification d'une catégorie
	$catlist[$arr["ID"]]=$arr["NOM"];
	$file=fopen("../data/categories.xml","w");
	fwrite($file,"<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n");
	fwrite($file,"<listecategories>\n");
	foreach ($catlist as $key=> $val){
		fwrite($file,"<categorie id='".$key."' nom='".$val."'></categorie>\n");
	}
	fwrite($file,"</listecategories>\n");
	fclose($file);
	return true;
}

function suppr_cat($catlist, $id){//fonction de suppression d'une catégorie
	$feedlist=feedList2();
	$feedlist2=suppr_feed_cat($feedlist, $id);
	unset($catlist[$id]);
	//maintenant il faut changer les id des catégories qui restent
	foreach ($catlist as $cle => $valeur){
		if ($cle > $id){
			$catlist[$cle-1]=$catlist[$cle];
			unset($catlist[$cle]);
		}
	}
	//ca c'est fait, mais maintenant et bien il faut changer les categories des flux restant !
	cge_cat_feed($feedlist2, $id);
	$file=fopen("../data/categories.xml","w");
	fwrite($file,"<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?>\n");
	fwrite($file,"<listecategories>\n");
	foreach ($catlist as $key=> $val){
		fwrite($file,"<categorie id='".$key."' nom='".$val."'></categorie>\n");
	}
	fwrite($file,"</listecategories>\n");
	fclose($file);
	return true;
}

/////////////////////////////////////////Fonctions d'ouverture et lecture des fichiers xml

function Ouvre_flux($parseur_feed,$balise,$attributs){ //Ouverture des flux
 	global $balise_o;
 	global $feeds;
 	$balise_o=$balise;
 	if ($balise_o == "FLUX"){
 	array_push($feeds,$attributs);
 	}
 	return $feeds;
 }
//
//
 function Ouvre_cat($parseur_cat,$balise,$attributs){ //Ouverture des catégories (c'est quand même con ce qu'on a fait, si on envoi la balise en paramètre, on n'a besoin que d'une fonction, à prévoir)
 	global $balise_o;
 	global $categories;
 	$balise_o=$balise;
 	if ($balise_o == "CATEGORIE"){
 	array_push($categories,$attributs);
 	}
 	return $categories;
 }
function Ouvre_conf2($parseur_cat,$balise,$attributs){ //Ouverture de la config
 	global $balise_o;
 	global $config;
 	$balise_o=$balise;
 	if ($balise_o == "CONF"){
 	array_push($config,$attributs);	
 	}
 	return $config;
 }
//
function Ouvre($parseur_user,$balise,$attributs){
		global $balise_o;
		global $users;
		$balise_o=$balise;
		if ($balise_o == "DATA"){
			array_push($users,$attributs);
		}
		return $users;
}
//
 function Ferme($parseur,$balise){} //Fermeture
//
function feedList(){ //Fonction qui retourne les flux
global $feeds;
$flux_string = file_get_contents("data/flux.xml");
$parser_feed = xml_parser_create();
xml_set_element_handler($parser_feed, "Ouvre_flux", "Ferme");
xml_parse($parser_feed, $flux_string) or die("Error parsing XML document.");
	$feeds=sortbyid($feeds);
return $feeds;
}
//
function feedList2(){ //Fonction qui retourne les flux avec un autre chemin (non mais là cest codé avec les pieds quand même hein, faut que j'améliore cette histoire de chemins)
global $feeds;
$flux_string = file_get_contents("../data/flux.xml");
$parser_feed = xml_parser_create();
xml_set_element_handler($parser_feed, "Ouvre_flux", "Ferme");
xml_parse($parser_feed, $flux_string) or die("Error parsing XML document.");
	$feeds=sortbyid($feeds);
return $feeds;
}
function catList(){ //Fonction qui retourne les catégories
	global $categories;
	$categorie_string=file_get_contents("data/categories.xml");
	$parser_cat=xml_parser_create();
	xml_set_element_handler($parser_cat,"Ouvre_cat","Ferme");
	xml_parse($parser_cat,$categorie_string) or die ("Error parsing XML document.");
	$tab=array();
	$categories=sortbyid($categories);
	foreach ($categories as $item){
		$tab[$item["ID"]]=$item["NOM"];
	}
	return $tab;
}
function catList2(){ // Pffff...
	global $categories;
	$categorie_string=file_get_contents("../data/categories.xml");
	$parser_cat=xml_parser_create();
	xml_set_element_handler($parser_cat,"Ouvre_cat","Ferme");
	xml_parse($parser_cat,$categorie_string) or die ("Error parsing XML document.");
	$tab=array();
	$categories=sortbyid($categories);
	foreach ($categories as $item){
		$tab[$item["ID"]]=$item["NOM"];
	}
	return $tab;
}
function getConf(){ // Fonction qui retourne la configuration
global $config;	
$flux_string = file_get_contents("data/conf.xml");
$parser_feed = xml_parser_create();
xml_set_element_handler($parser_feed, "Ouvre_conf2", "Ferme");
xml_parse($parser_feed, $flux_string) or die("Error parsing XML document.");
return $config;
}
//
function userList(){
		global $users;
		$user_string = file_get_contents("data/auth.xml");
		$parser_user = xml_parser_create();
		xml_set_element_handler($parser_user, "Ouvre", "Ferme");
		xml_parse($parser_user, $user_string) or die("Error parsing XML document.");
		return $users;
}
///////////////////////////////////////Utilities


function sortbyid($tab){ //sortbyid qui sort by ordre en fait...
	foreach ($tab as $key => $row) {
		$id[$key]  = $row['ORDRE'];
	}

	array_multisort($id, SORT_ASC, $tab);
	return $tab;
}
function sortbyidbis($tab){ //le vrai sortbyid
	foreach ($tab as $key => $row) {
		$id[$key]  = $row['ID'];
	}

	array_multisort($id, SORT_ASC, $tab);
	return $tab;
}
function getkey($tab, $id){
	foreach ($tab as $key => $val){
		if($tab[$key]['ID']==$id){
			$result=$key;
		}
	}
return $result;
}

////////////////////////////////////////////////////////////////Fonctions test login admin//////////////////////////////////////////////////////

function test_log() {
  if ($_SESSION['logok']!=1) {
	session_unset();
	session_destroy();
	/*echo "Veuillez vous identifier !"; --> Pas de echo avant d'envoyer les headers
	   sinon warning Cannot modify header information
	   - headers already sent by (output started at C:\Users\laurent\Downloads\xampplite\htdocs\planet\bin\functions.php:75) in C:\Users\laurent\Downloads\xampplite\htdocs\planet\bin\functions.php on line 76*/
	//Laurent il développe sous windows nananère.
	header("Location: admin/auth.php");
	exit;
	}
}
function test_log_bis() {
  if ($_SESSION['logok']!=1) {
	session_unset();
	session_destroy();
	/*echo "Veuillez vous identifier !"; --> Pas de echo avant d'envoyer les headers
	   sinon warning Cannot modify header information
	   - headers already sent by (output started at C:\Users\laurent\Downloads\xampplite\htdocs\planet\bin\functions.php:75) in C:\Users\laurent\Downloads\xampplite\htdocs\planet\bin\functions.php on line 76*/
	header("Location: ../admin/auth.php");
	exit;
	}
}
?>
